#ifndef WLANCONFIG_H
#define WLANCONFIG_H

#define PLATFORM_FREERTOS 1
#define CONFIG_LITTLE_ENDIAN
#define CONFIG_GSPI_HCI
//#define CONFIG_SDIO_HCI
#define CONFIG_80211N_HT
//#define CONFIG_RECV_REORDERING_CTRL
#define RTW_NOTCH_FILTER 0
#define CONFIG_EMBEDDED_FWIMG 1
#define CONFIG_PHY_SETTING_WITH_ODM
#define CONFIG_ODM_REFRESH_RAMASK
#define HAL_MAC_ENABLE 1
#define HAL_BB_ENABLE 1
#define HAL_RF_ENABLE 1

#define CONFIG_DEBUG
#define CONFIG_DEBUG_RTL871X
#define CONFIG_MEM_MONITOR	MEM_MONITOR_LEAK
//#define WLAN_INTF_DBG		 

#define CONFIG_POWER_SAVING
#define CONFIG_LPS
#define CONFIG_IPS
//#define CONFIG_LPS_LCLK	// ToDo

#define CONFIG_XMIT_THREAD_MODE
//#define CONFIG_RECV_THREAD_MODE				/* Wlan IRQ Polling  Mode*/
//#define CONFIG_RECV_TASKLET_THREAD
//#define CONFIG_ISR_THREAD_MODE_POLLING		/* Wlan IRQ Polling  Mode*/
#define CONFIG_ISR_THREAD_MODE_INTERRUPT	/* Wlan IRQ Interrupt  Mode*/
#if defined(CONFIG_ISR_THREAD_MODE_POLLING) && defined(CONFIG_ISR_THREAD_MODE_INTERRUPT)
#error "CONFIG_ISR_THREAD_MODE_POLLING and CONFIG_ISR_THREAD_MODE_INTERRUPT are mutually exclusive. "
#endif


/* CRC DMEM optimized mode consume 1k less SRM memory consumption */
#define CRC_IMPLEMENTATION_MODE CRC_IMPLEMENTATION_DMEM_OPTIMIZED

/* AES DMEM optimized mode comsume 10k less memory compare to 
     IMEM optimized mode AES_IMPLEMENTATION_IMEM_OPTIMIZED */
#define AES_IMPLEMENTATION_MODE AES_IMPLEMENTATION_DMEM_OPTIMIZED

#define USE_SKB_AS_XMITBUF	1
#define USE_XMIT_EXTBUFF	0
#define USE_MUTEX_FOR_SPINLOCK	1
#define SUPPORT_5G_CHANNEL	0
#define SUPPORT_FAKE_EFUSE	0
//#define CONFIG_AUTO_RECONNECT
#define ENABLE_HWPDN_PIN
#define SUPPORT_SCAN_BUF	1

/* For WPA2 */
#define CONFIG_INCLUDE_WPA_PSK

#ifdef CONFIG_INCLUDE_WPA_PSK
#define CONFIG_MULTIPLE_WPA_STA
//#define CONFIG_WPA2_PREAUTH
#define PSK_SUPPORT_TKIP	1
#endif

/* For promiscuous mode */
#define CONFIG_PROMISC
#define PROMISC_DENY_PAIRWISE	0

/* For AP_MODE */
#define CONFIG_AP_MODE
#define AP_STA_NUM	3	//Not less than 1

//#define CONFIG_CONCURRENT_MODE
/* For WPS and P2P */
//#define CONFIG_WPS 
//#ifdef CONFIG_WPS
//#define CONFIG_P2P 	 
//#endif

/* For Tx Power By Rate */
#define CONFIG_INIT_TXPWR_BY_RATE 0

#ifdef CONFIG_AP_MODE
	#define CONFIG_NATIVEAP_MLME
	#define CONFIG_INTERRUPT_BASED_TXBCN

	#ifdef CONFIG_INTERRUPT_BASED_TXBCN
		//#define CONFIG_INTERRUPT_BASED_TXBCN_EARLY_INT
		#define CONFIG_INTERRUPT_BASED_TXBCN_BCN_OK_ERR
	#endif

//	#define CONFIG_GK_REKEY
	#define USE_DEDICATED_BCN_TX	1
#else
	#define USE_DEDICATED_BCN_TX	0
#endif

#if defined(CONFIG_AP_MODE) && defined(CONFIG_GK_REKEY) && !defined(CONFIG_MULTIPLE_WPA_STA)
#error "If CONFIG_GK_REKEY when CONFIG_AP_MODE, need to CONFIG_MULTIPLE_WPA_STA"
#endif

/* For MP_MODE */
//#define CONFIG_MP_INCLUDED
#ifdef CONFIG_MP_INCLUDED
	#define MP_DRIVER		1
	#define CONFIG_MP_IWPRIV_SUPPORT
#else
	#define MP_DRIVER		0
#endif // #ifdef CONFIG_MP_INCLUDED

#define CONFIG_RTL8188E
//#define RTL8188ES_SUPPORT 1
#define RTL8188E_SUPPORT 1
#define RTL8192C_SUPPORT 0
#define RTL8192CE_SUPPORT 0
#define RTL8192CU_SUPPORT 0
#define RTL8192D_SUPPORT 0
#define RTL8192DE_SUPPORT 0
#define RTL8192DU_SUPPORT 0
#define RTL8723A_SUPPORT 0
#define RTL8723AU_SUPPORT 0
#define RTL8723AS_SUPPORT 0
#define RTL8192E_SUPPORT 0
#define RTL8812A_SUPPORT 0
#define RTL8821A_SUPPORT 0
#define RTL8723B_SUPPORT 0
#define RTL8195A_SUPPORT 0
#define RTL8711B_SUPPORT 0
#define TEST_CHIP_SUPPORT 0

#define RTL8723_FPGA_VERIFICATION 0
#define RTL8188E_FOR_TEST_CHIP 0
#define RTL8188E_FPGA_TRUE_PHY_VERIFICATION 0
#define DISABLE_BB_RF 0
#define DBG 0
#define RATE_ADAPTIVE_SUPPORT 1

#define CONFIG_LWIP_LAYER    1
#endif //WLANCONFIG_H
